#include "MinCutLinearArrangement.h"

void getInputParameter(char *, char *);
void InitializeGraph(char*, int *, int *);
void InitializeInputArray(char *, int **, int);

int num_of_vertices, num_of_edges, **input_arr;

int main(int argc, char *argv[]){	
	int i = 0, j = 0,count=1;
    LPX *lp;
    char *name;
    int k=0,index=0,u,v,t;
	int rowNum = 0;   
    int numVariables = 0;
    int *ia, *ja;
    double *ar;
        	
	if ( argc < 1 ){
		printf("MinCutLA filename\n");
		return 0;
	}
	
	printf("argc = %d\n", argc);
	for(i = 0; i < argc; i++)
		printf("arg %d: %s\n", i, argv[i]);

	/* Initialization Phase...*/
	InitializeGraph(argv[1], &num_of_vertices, &num_of_edges);
	
	input_arr = (int **)malloc(sizeof(int)*num_of_edges);
	for (i=0;i<num_of_edges;i++){
		input_arr[i] = (int *)malloc(sizeof(int)*3);
	}
	
	InitializeInputArray(argv[1], input_arr,num_of_vertices);
	
	/* Check the input file...*/
	if (isDebug == 1) printf("%d %d\n", num_of_vertices, num_of_edges);	
	for (i=0;i<num_of_edges;i++){
		if (isDebug == 1) printf("%d %d %d \n",input_arr[i][0], input_arr[i][1],input_arr[i][2]);
	}
	
	/*greedy heuristic approach...*/ 
	rowNum = num_of_vertices + num_of_vertices + num_of_edges*num_of_vertices + num_of_edges*num_of_vertices*num_of_vertices*num_of_vertices;   
    numVariables = 1 + num_of_vertices*num_of_vertices + num_of_vertices*num_of_edges;
    ia = (int *)malloc(sizeof(int)*(1+rowNum*numVariables));
    ja = (int *)malloc(sizeof(int)*(1+rowNum*numVariables));
    ar = (double *)malloc(sizeof(double)*(1+rowNum*numVariables));
    name = (char *)malloc(sizeof(char)*(MAX_STR_LENGTH));
	  
    lp = lpx_create_prob();
    lpx_set_prob_name(lp, "MinCutLA");
    lpx_set_obj_dir(lp, LPX_MIN);
    	
    lpx_add_cols(lp, numVariables+1);
    for (i =0; i< numVariables; i++){

    	if (i==0){
		    //lpx_set_col_name(lp, i+1, "M");
		    lpx_set_col_bnds(lp, i+1, LPX_DB, 0.0, num_of_edges);
		    lpx_set_obj_coef(lp, i+1, 1);
    	}else if (i <= num_of_vertices*num_of_vertices ){/* X[0..n-1, 0..n-1] */
     		//sprintf(name, "X[%d,%d]",i/num_of_vertices,i%num_of_vertices);
    		//if (isDebug == 1) printf("%s\n", name);
    		//lpx_set_col_name(lp, i+1, name);
		    lpx_set_col_bnds(lp, i+1, LPX_DB, 0.0, 1.0);
		    lpx_set_obj_coef(lp, i+1, 0);
    	}else{/* e[edge, 0..n-1] */
    		//sprintf(name, "e[%d,%d]",(i-num_of_vertices*num_of_vertices)/num_of_vertices,(i-num_of_vertices*num_of_vertices)%num_of_edges);
    		//if (isDebug == 1) printf("%s\n", name);
    		//lpx_set_col_name(lp, i+1, name);
		    lpx_set_col_bnds(lp, i+1, LPX_DB, 0.0, 1.0);
		    lpx_set_obj_coef(lp, i+1, 0);
    	}
    }
    if (isDebug == 1) printf("%d, %d %d \n", rowNum, numVariables, 1+rowNum*numVariables);
        
    lpx_add_rows(lp, rowNum+1);   
    for (j =0; j < 2*num_of_vertices+ num_of_edges*num_of_vertices; j++){
    	//sprintf(name, "p",j);
	    //lpx_set_row_name(lp, j+1, name);  
    	
	    if (j < num_of_vertices){
	    	lpx_set_row_bnds(lp, j+1, LPX_FX, 1.0, 1.0);
	    	
	    	/*Coefficiency */
	    	k = j;
	    	for (i =0; i < numVariables; i++){
	    		if (i>0 && (i <= num_of_vertices*num_of_vertices) && ((i-1)%num_of_vertices == k)){
	    			ia[count] = j+1;
	    			ja[count] = i+1;
	    			
	    			ar[count] = 1;
	    			count++;
	    		}
	    	}
	    }else if (j< 2*num_of_vertices){
    		lpx_set_row_bnds(lp, j+1, LPX_FX, 1.0, 1.0);
    		
    		/*Coefficiency */
	    	k = j-num_of_vertices;
	    	for (i =0; i < numVariables; i++){
	    		if (i>0 && (i <=num_of_vertices*num_of_vertices) && (i-1)/num_of_vertices == k){
	    			ia[count] = j+1;
	    			ja[count] = i+1;
	    			ar[count] = 1;
	    			count++;
	    		}
	    	}
	    }else if (j<2*num_of_vertices+ num_of_edges*num_of_vertices){
    		lpx_set_row_bnds(lp, j+1, LPX_UP, 0.0, 0.0);
    		
    		/*Coefficiency */
	    	k = j-2*num_of_vertices;
	    	for (i =0; i < numVariables; i++){
	    		if (i>num_of_vertices*num_of_vertices && ((i-1-num_of_vertices*num_of_vertices)%num_of_edges == k)){
	    			ia[count] = j+1;
	    			ja[count] = i+1;
	    			ar[count] = 1;
	    			count++;
	    		}
	    	}
	    }
    }

	{
    	/*Coefficiency */
    	//k = j-2*num_of_vertices+ num_of_edges*num_of_vertices;
    	for (index =0; index < num_of_edges; index++){
    		i = input_arr[index][0];
    		t = input_arr[index][1];
			for (u=0;u< num_of_vertices;u++){
				for (v=0;v< num_of_vertices;v++){
					for (k=0;k< num_of_vertices;k++){
						if (k<v && u<=k){
    						lpx_set_row_bnds(lp, j+1, LPX_UP, 0.0, 1.0);								
							ia[count] = j+1;
				    		ja[count] = i*num_of_vertices + u+2;
							ar[count] = 1;
							count++;
							j++;
							
 							ia[count] = j+1;
				    		ja[count] = t*num_of_vertices + v+2;								
							ar[count] = 1;
							count++;								
							j++;
							
							ia[count] = j+1;
				    		ja[count] = index*num_of_vertices + k+1+num_of_vertices*num_of_vertices+1;									
							ar[count] = -1;
							count++;
							j++;
						}
					}   		
				}   		
			}   		
    	}
    }
	if (isDebug == 1) printf("%d\n", count);
	
    lpx_load_matrix(lp, count-1, ia, ja, ar);
    lpx_simplex(lp);
    printf("\nZ = %d ;\n", lpx_get_obj_val(lp) );
    
	for (u=0;u< num_of_vertices;u++){
		for (v=0;v< num_of_vertices;v++){
			if (lpx_get_col_prim(lp, 1+u*num_of_vertices +v)>0)
				printf("%d corresponds to %d, isBelongTo=%d\n", u, v, lpx_get_col_prim(lp, 1+u*num_of_vertices +v));
		}   		
	} 
	for (u=0;u< num_of_edges;u++){
		for (v=0;v< num_of_vertices;v++){
			if (lpx_get_col_prim(lp, 1+num_of_vertices*num_of_vertices+u*num_of_vertices +v)>0)
				printf("edge from=%d to=%d k=%d, isBelongTo=%d\n", input_arr[u][0],input_arr[u][1], v, lpx_get_col_prim(lp, 1+num_of_vertices*num_of_vertices+u*num_of_vertices +v));
		}   		
	}     		
    lpx_delete_prob(lp);
    return 0;
}

void InitializeGraph(char *inputF, int *num_of_vertices, int *num_of_edges){
	FILE *f_input_file;
	char line[MAX_STR_LENGTH],ch[16];

	f_input_file = fopen(inputF, "r");
	if (f_input_file == NULL){
		printf("Cannot open input file!");
		exit(1);
	}

	/* Getting the number of vertices, and number of edges parameters for the input graph */
	fgets(line,MAX_STR_LENGTH,f_input_file);
	getInputParameter(line, ch );
	*num_of_vertices = atoi(ch);
	
	fgets(line,MAX_STR_LENGTH,f_input_file);
	getInputParameter(line, ch );
	*num_of_edges = atoi(ch);
		
	fclose(f_input_file);
}

void getInputParameter(char * line, char * ch ){
	int isFirst = 1,i=0,j=0;
	if (line == NULL || ch == NULL)
		return;
		
	while (line[i]!='\0'){
		if ( isFirst && line[i] != '=' )
			i++;
		else {
			if ( isFirst == 1 ){
				isFirst = 0;
				i++;
			}
			
			ch[j++] = line[i++];
		}

	}
	ch[j]='\0';
}

void InitializeInputArray(char * inputF, int **input_arr, int num_of_vertices){
	FILE *f_input_file;
	char line[MAX_STR_LENGTH],ch[16];
	int graph_parameters[3],i,j,k=0,index=0;

	for (i=0;i<num_of_vertices;i++){
		for (j=0;j<num_of_vertices;j++){
			input_arr[i][j]=0;
		}
	}

	f_input_file = fopen(inputF, "r");
	if (f_input_file == NULL){
		printf("Cannot open input file!");
		exit(1);
	}
		
	fgets(line,MAX_STR_LENGTH,f_input_file); /* Bypass the first line with number of vertices, edges...etc */
	fgets(line,MAX_STR_LENGTH,f_input_file); /* Bypass the first line with number of vertices, edges...etc */

	while (fgets(line,MAX_STR_LENGTH,f_input_file)){
		k = 0;
		i = 0;
		j = 0;
		while (line[i]!='\0'){
			if (line[i]==' '){
				ch[j]='\0';	
				graph_parameters[k++] = atoi(ch);
				j=0;
				i++;
				continue;
			}
	
			ch[j++] = line[i++];
		}
	
		ch[j]='\0';
		graph_parameters[k] = atoi(ch);
		
		input_arr[index][0] =graph_parameters[0];
		input_arr[index][1] =graph_parameters[1];
		if (k>=2)
			input_arr[index][2] =graph_parameters[2];
		else
			input_arr[index][2] = 1;
		index++;
	}

	fclose(f_input_file);
}
